=== debian/changelog ===
tbb (4.3~20150611-2) unstable; urgency=medium

  * Add support for armel by distinguishing from armhf.
  * Fold in unit test timeout logic in to tally patch.

 -- Steve Capper <steven.capper@gmail.com>  Fri, 03 Jun 2016 20:30:33 +0100

tbb (4.3~20150611-1) unstable; urgency=medium

  * Dump out /proc/cpuinfo and gcc preprocessor directives on build to
    help debug issues.
  * Timeout of 10 minutes set on unit tests. Any tests that timeout are
    logged.

  [Mathieu Malaterre ]
  * Tweak 64 bits detection.

 -- Steve Capper <steven.capper@gmail.com>  Mon, 30 May 2016 17:01:44 +0100

tbb (4.3~20150611-0.1) unstable; urgency=medium

  * Non-maintainer upload.

  [ Matthias Klose ]
  * Upload version from experimental to sid, fixing build with GCC 5.
    Closes: #778139.
  * The architecture list is now marked as linux-any. Closes: #748876.
  * Multiarchify the packages (Marc Glisse). Closes: #751689.
  * The new upstream fixes the check for __TBB_CPP11_TYPE_PROPERTIES_PRESENT.
    Closes: #779553.

  [ Adam Conrad ]
  * gcc-atomic-detection.patch: Fix the gcc atomic detection to work for
    gcc-5.x and up, as well as adding -latomic to LIBS (closes: #787084)
  * gcc-atomic-always.patch: Always define TBB_USE_GCC_BUILTINS for GCC.
  * debian/tbb.pc.in: Add -latomic to the pkg-config file for the above.

 -- Matthias Klose <doko@debian.org>  Sat, 05 Sep 2015 19:06:39 +0200

tbb (4.3~20150611-1~exp3) experimental; urgency=medium

  * Put Mathieu's ppc32 gcc atomic disable patch back in (it shouldn't
      have been removed).
  * Switch target architecture to linux-any.
  * Go full atomic, move all __sync to __atomic.

 -- Steve Capper <steven.capper@gmail.com>  Fri, 03 Jul 2015 20:20:34 +0100

tbb (4.3~20150611-1~exp2) experimental; urgency=medium

  * Replace __sync_val_compare_and_swap with __atomic_compare_exchange_n for
    gcc_generic.h
    - Original patch by Mathieu Malaterre, some logic has been tweaked.

 -- Steve Capper <steven.capper@gmail.com>  Thu, 02 Jul 2015 19:32:04 +0100

tbb (4.3~20150611-1~exp1) experimental; urgency=medium

  * New upstream release.
    + Mainly C++11 features/fixes.

 -- Steve Capper <steven.capper@gmail.com>  Sat, 20 Jun 2015 16:31:03 +0100

tbb (4.2~20140122-6) experimental; urgency=medium

  * First stab at an experimental upload.
  * No substantive changes from -5.

 -- Steve Capper <steven.capper@gmail.com>  Mon, 27 Apr 2015 21:37:32 +0100
